module Cell
  module Console
    def self.default_console_tenant
      if ENV['T'].present?
        Model.cell_find!(ENV['T'])
      elsif Rails.env.development? && ENV['T'] != ''
        Model.first
      end
    # These are so 'rails c' still works before the DB has been created, or the
    # Model class's table does not exist before db:migrate.
    rescue ::ActiveRecord::NoDatabaseError
      nil
    rescue ::ActiveRecord::StatementInvalid => e
      raise unless e.cause.is_a?(::PG::UndefinedTable)
      nil
    end

    def self.configure!
      if (t = default_console_tenant)
        Model.set!(t)
      end
    end
  end
end

Cell::Console.configure!
