module Cell
  module Ext
    module ActiveJob
      KEY = :'Cell.cell_id'

      def serialize
        if (current_id = Model.current&.cell_id)
          super.merge(KEY => current_id)
        else
          super
        end
      end

      def deserialize(job_data)
        if job_data.key?(KEY)
          self.cell_tenant = Model.cell_find(job_data[KEY])
        end
        super
      end

      def self.prepended(cls)
        cls.send(:attr_accessor, :cell_tenant)
        cls.around_perform do |job, block|
          Model.use(job.cell_tenant, &block)
        end
      end
    end
  end
end

ActiveSupport::on_load(:active_job) do
  ActiveJob::Base.prepend(Cell::Ext::ActiveJob)
end
