module Cell
  class Railtie < Rails::Railtie
    rake_tasks do
      load 'cell/tasks/cell.rake'
    end

    console do
      require 'cell/console'
    end

    config.after_initialize do
      require 'cell/tenant'
      require 'cell/sanity_check'
      require 'cell/ext/active_record'
      require 'cell/ext/migration'
      require 'cell/ext/active_job'
    end
  end

  def self.const_missing(name)
    return super unless name == :Model

    Rails.application.eager_load!
    unless const_defined?(:Model)
      fail "Eager loaded models to find one that uses `include Cell::Tenant`.  Didn't pan out."
    end

    Model
  end
end
