module Cell
  module UrlOptions
    def self.prepended(cls)
      cls.after_set  :change_url_options, if: :has_cell_host?
      cls.around_use :change_url_options, if: :has_cell_host?
    end

    def has_cell_host?
      respond_to?(:cell_host)
    end

    private
    def change_url_options(&block)
      saved = Rails.application.routes.default_url_options[:host]
      Rails.application.routes.default_url_options[:host] = cell_host

      if block_given?
        begin
          yield
        ensure
          Rails.application.routes.default_url_options[:host] = saved
        end
      end
    end
  end
end
